#!/usr/bin/python3
import sys
import codecs
import traceback
import requests
import re
import pandas as pd
import random
import urllib
import dataset
import json
import gspread
import datetime
from gspread_pandas import Spread, Client
from oauth2client.service_account import ServiceAccountCredentials
import os
import threading
from apiclient.discovery import build
from oauth2client.service_account import ServiceAccountCredentials
import dataset

db = dataset.connect('mysql://choozmo:pAssw0rd@db.ptt.cx:3306/hhh?charset=utf8mb4')
db.query('delete from ga_designer_path')
db.begin()

table=db['ga_designer_path']

SCOPES = ['https://www.googleapis.com/auth/analytics.readonly']
KEY_FILE_LOCATION = 'c:\\keys\\choozmo-ga-beee24b7a4c1.json'
VIEW_ID = '188916214'


def initialize_analyticsreporting():
  """Initializes an Analytics Reporting API V4 service object.

  Returns:
    An authorized Analytics Reporting API V4 service object.
  """
  credentials = ServiceAccountCredentials.from_json_keyfile_name(
      KEY_FILE_LOCATION, SCOPES)

  # Build the service object.
  analytics = build('analyticsreporting', 'v4', credentials=credentials)

  return analytics


def get_report(analytics,body):
  """Queries the Analytics Reporting API V4.

  Args:
    analytics: An authorized Analytics Reporting API V4 service object.
  Returns:
    The Analytics Reporting API V4 response.
  """
  return analytics.reports().batchGet(
      body={
        'reportRequests':body
      }
  ).execute()


def print_response(response):
  """Parses and prints the Analytics Reporting API V4 response.

  Args:
    response: An Analytics Reporting API V4 response.
  """
  result=[]
  for report in response.get('reports', []):
    columnHeader = report.get('columnHeader', {})
    dimensionHeaders = columnHeader.get('dimensions', [])
    metricHeaders = columnHeader.get('metricHeader', {}).get('metricHeaderEntries', [])

    for row in report.get('data', {}).get('rows', []):
      dimensions = row.get('dimensions', [])
      dateRangeValues = row.get('metrics', [])
      ga_dict={}

      for header, dimension in zip(dimensionHeaders, dimensions):
#        print(header + ': ', dimension)
        ga_dict[header]=dimension
      
      for i, values in enumerate(dateRangeValues):
#        print('Date range:', str(i))
        for metricHeader, value in zip(metricHeaders, values.get('values')):
          ga_dict[metricHeader.get('name')]=value
#          print(metricHeader.get('name') + ':', value)
        result.append(ga_dict)
    return result
#        print(ga_dict)

def main():
  analytics = initialize_analyticsreporting()
#(FB_|facebook|IG_|LINE_|LINEMP_|qsear.ch)

  body=[{ 'viewId': VIEW_ID,
#  'dateRanges': [{'startDate': '2021-03-01', 'endDate': '2021-06-24'}],
  'dateRanges': [{'startDate': '2021-07-01', 'endDate': '2021-07-16'}],

#  'dateRanges': [{'startDate': '2021-06-01', 'endDate': '2021-06-24'}],

  'metrics': [{'expression': 'ga:users'},{'expression': 'ga:newusers'},{'expression': 'ga:sessions'},{'expression': 'ga:pageviews'},{'expression': 'ga:bounceRate'},{'expression': 'ga:pageviewsPerSession'}],
  'dimensions': [{'name': 'ga:landingPagePath'},{'name': 'ga:secondPagePath'}],
#  'filters':'ga:secondPagePath=@/designers/cases/',
  "dimensionFilterClauses": 
      [
        {
          "filters": 
          [
            {
              "dimensionName": "ga:secondPagePath",
              "operator": "REGEXP", 
              "expressions": ['/designers/cases/']
            }
          ]
        }
      ],

#  'filters':[{'expression':'ga:secondPagePath=@/designers/cases/'}],
#  "filtersExpression":[{"expression":"ga:secondPagePath=@/designers/cases/"}],
#'dimensionFilterClauses': [
#                            {"filters": [{"dimensionName": "ga:secondPagePath",
#                                          "operator": "=@",
#                                          "expressions": ["/designers/cases/"]}]
#                            }
#                                        ],


#  "filters":[{"expression":"ga:secondPagePath=@/designers/cases/"}],

#  'orderBys':[{"fieldName": "ga:pageviews", "sortOrder": "DESCENDING"}],
  'pageSize': '2000'
  }]

  response = get_report(analytics,body)
  ga_dict=print_response(response)

  result=[]
  for elmt in ga_dict:
#      elmt['ga:landingPagePath']='https://hhh.com.tw'+elmt['ga:landingPagePath']
      txt=elmt['ga:landingPagePath']
      e2=txt.split('/')
      if len(e2)>2:
          elmt['orig']='/'+e2[1]+'/'+e2[2]+"/"
      else:
          elmt['orig']='/'+e2[1]+'/'

#      elmt['ga:landingPagePath']=elmt['ga:landingPagePath']

#      print(elmt)
      result.append(elmt)
  print('inserting.....')
  for r in result:
    try:
      table.insert(r)
    except:
      print('exception')
db.commit()
#      elmt['category']='social'


if __name__ == '__main__':
  main()

